/* LekhoneeOperations.c generated by valac 0.12.0, the Vala compiler
 * generated from LekhoneeOperations.vala, do not modify */

/* LekhoneeDialogs.vala
 *
 * Copyright (C) 2010  Kushal Das <kushal@fedoraproject.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <stdio.h>

#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



void xml_save_file (const gchar* filename, const gchar* title, const gchar* desc, const gchar* tags);
void xml_open_file (const gchar* path, gchar** title, gchar** desc, gchar** tags);


void xml_save_file (const gchar* filename, const gchar* title, const gchar* desc, const gchar* tags) {
	xmlDoc* doc = NULL;
	xmlNode* root = NULL;
	xmlDoc* _tmp0_ = NULL;
	xmlNode* _tmp1_ = NULL;
	FILE* _tmp2_ = NULL;
	FILE* stream;
	g_return_if_fail (filename != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (desc != NULL);
	g_return_if_fail (tags != NULL);
	_tmp0_ = xmlNewDoc ("1.0");
	doc = _tmp0_;
	_tmp1_ = xmlNewNode (NULL, "post");
	root = _tmp1_;
	xmlDocSetRootElement (doc, root);
	xmlNewTextChild (root, NULL, "title", title);
	xmlNewTextChild (root, NULL, "description", desc);
	xmlNewTextChild (root, NULL, "tags", tags);
	_tmp2_ = fopen (filename, "w");
	stream = _tmp2_;
	xmlDocDump (stream, doc);
	_fclose0 (stream);
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


void xml_open_file (const gchar* path, gchar** title, gchar** desc, gchar** tags) {
	gchar* _title = NULL;
	gchar* _desc = NULL;
	gchar* _tags = NULL;
	xmlDoc* _tmp0_ = NULL;
	xmlDoc* doc;
	xmlNode* _tmp1_ = NULL;
	xmlNode* root;
	g_return_if_fail (path != NULL);
	_tmp0_ = xmlParseFile (path);
	doc = _tmp0_;
	if (doc == NULL) {
		fprintf (stderr, "File %s not found or permissions missing", path);
		if (title) {
			*title = _title;
		} else {
			_g_free0 (_title);
		}
		if (desc) {
			*desc = _desc;
		} else {
			_g_free0 (_desc);
		}
		if (tags) {
			*tags = _tags;
		} else {
			_g_free0 (_tags);
		}
		return;
	}
	_tmp1_ = xmlDocGetRootElement (doc);
	root = _tmp1_;
	if (root == NULL) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		xmlFreeDoc (doc);
		_tmp2_ = string_to_string (path);
		_tmp3_ = g_strconcat ("The xml file '", _tmp2_, "' is empty", NULL);
		_tmp4_ = _tmp3_;
		g_debug ("LekhoneeOperations.vala:55: %s", _tmp4_);
		_g_free0 (_tmp4_);
		if (title) {
			*title = _title;
		} else {
			_g_free0 (_title);
		}
		if (desc) {
			*desc = _desc;
		} else {
			_g_free0 (_desc);
		}
		if (tags) {
			*tags = _tags;
		} else {
			_g_free0 (_tags);
		}
		return;
	}
	{
		xmlNode* iter;
		iter = root->children;
		{
			gboolean _tmp5_;
			_tmp5_ = TRUE;
			while (TRUE) {
				gchar* _tmp6_;
				gchar* node_name;
				gchar* _tmp7_ = NULL;
				gchar* node_content;
				if (!_tmp5_) {
					iter = iter->next;
				}
				_tmp5_ = FALSE;
				if (!(iter != NULL)) {
					break;
				}
				if (iter->type != XML_ELEMENT_NODE) {
					continue;
				}
				_tmp6_ = g_strdup (iter->name);
				node_name = _tmp6_;
				_tmp7_ = xmlNodeGetContent (iter);
				node_content = _tmp7_;
				if (g_strcmp0 (node_name, "title") == 0) {
					gchar* _tmp8_;
					_tmp8_ = g_strdup (node_content);
					_g_free0 (_title);
					_title = _tmp8_;
				}
				if (g_strcmp0 (node_name, "description") == 0) {
					gchar* _tmp9_;
					_tmp9_ = g_strdup (node_content);
					_g_free0 (_desc);
					_desc = _tmp9_;
				}
				if (g_strcmp0 (node_name, "tags") == 0) {
					gchar* _tmp10_;
					_tmp10_ = g_strdup (node_content);
					_g_free0 (_tags);
					_tags = _tmp10_;
				}
				_g_free0 (node_content);
				_g_free0 (node_name);
			}
		}
	}
	xmlFreeDoc (doc);
	if (title) {
		*title = _title;
	} else {
		_g_free0 (_title);
	}
	if (desc) {
		*desc = _desc;
	} else {
		_g_free0 (_desc);
	}
	if (tags) {
		*tags = _tags;
	} else {
		_g_free0 (_tags);
	}
}



